{
********************************************************************************
Mdulo:        TmpTable
Versin:       1.0
Descripcin:   Tabla temporal en C:\Windows\Temp. FREEWARE
Autor:         Favio E. Ugalde Corral
Creacin:       4 de diciembre  de 1996
Modificacin:  14 de agosto     de 1998
E-Mail:        fugalde@geocities.com
URL:           "Delphi en Espaol" http://www.geocities.com/~fugalde
Observaciones: ninguna
********************************************************************************
}

unit TmpTable;

interface

uses
  SysUtils, Windows, DBTables, Classes;

type

{ TTmpTable }

  TTmpTable = class(TTable)
  private
    FTemporal: Boolean;
  protected
    procedure CloseCursor; override;
  public
    constructor Create(AOwner: TComponent); override;
    procedure CreateTmpTable;  // Crea una tabla temporal
    property Temporal: Boolean read FTemporal;  // Es una tabla temporal?
  end;

// Devuelve un nombre nico de archivo de 8 posiciones basado en la fecha y hora del sistema.
function  GetUniqueFileName: string;
// Devuelve la carpeta temporal de Windows.
function  GetTempDirectory: string;

procedure Register;

implementation

// Devuelve un nombre nico de archivo de 8 posiciones basado en la fecha y hora del sistema.
function  GetUniqueFileName: string;
begin
  Result := Format('%8x', [DateTimeToFileDate(Now())]);
end;

// Devuelve la carpeta temporal de Windows.
function  GetTempDirectory: string;
begin
  SetLength(Result, 255);
  GetTempPath(255, PChar(Result));
end;

{ TTmpTable }

constructor TTmpTable.Create(AOwner: TComponent);
begin
  inherited Create(AOwner);

  FTemporal := False;
end;

procedure TTmpTable.CreateTmpTable;
begin
  FTemporal := True;
  try
    DatabaseName := GetTempDirectory;
    TableName    := GetUniqueFileName;
    CreateTable;
  except
    FTemporal := False;
    raise;
  end;
end;

procedure TTmpTable.CloseCursor;
begin
  inherited CloseCursor;

  // Elimina la tabla si es temporal
  if FTemporal then
    begin
    FTemporal := False;
    DeleteTable;
    end;
end;

procedure Register;
begin
  RegisterComponents('Data Access', [TTmpTable]);
end;

end.

